// -*- c++ -*-
/***************************************************************************
                           qvideo.h
                           --------
    begin                : Sat Jun 12 2004
    copyright            : (C) 2004 by Dirk Ziegelmeier
    email                : dziegel@gmx.de
 ***************************************************************************/

/*
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public License
 * along with this library; see the file COPYING.LIB.  If not, write to
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 */

#ifndef QVIDEO_H
#define QVIDEO_H

class QVideo
{
public:
    typedef enum {
        FORMAT_NONE    =     0,
        FORMAT_RGB32   =     1,
        FORMAT_RGB24   =     2,
        FORMAT_RGB555  =     4,
        FORMAT_RGB565  =     8,
        FORMAT_YUV422  =    16,
        FORMAT_YUYV    =    32,
        FORMAT_UYVY    =    64,
        FORMAT_YUV420  =   128,
        FORMAT_YUV411  =   256,
        FORMAT_YUV422P =   512,
        FORMAT_YUV411P =  1024,
        FORMAT_YUV420P =  2048,
        FORMAT_YUV410P =  4096,
        FORMAT_GREY    =  8194,
        FORMAT_HI240   = 16388
    } ImageFormat;

    typedef enum {
        METHOD_NONE  =  0,
        METHOD_XSHM  =  1,
        METHOD_XV    =  2,
        METHOD_XVSHM =  4,
        METHOD_X11   =  8,
        METHOD_DGA   = 16, /* unimplemented */
        METHOD_GL    = 32,
        METHOD_SDL   = 64 /* unimplemented */
    } VideoMethod;
    
    static unsigned int bytesppForFormat(ImageFormat fmt);
    static bool findDisplayProperties(ImageFormat& fmt, int& depth, int& bitsperpixel, int& bytesperpixel);
};

#endif //QVIDEO_H

